package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.DataEntity;

/**
 * 实体[UserRoleDEField] 数据对象
 */
@TableName(value = "T_SRFUSERROLEDEFIELD",resultMap = "UserRoleDEFieldResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserRoleDEField extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private DataEntity de;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_CodeList88CodeList")
    private String defaction;
    private String deid;
    private String dename;
    private String relateddefield;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfsyspub;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfuserpub;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "userroledefieldid",type=IdType.UUID)//指定主键生成策略
    private String userroledefieldid;
    private String userroledefieldname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[访问行为]
     *  @param defaction
     */
    public void setDefaction(String defaction){
        if(StringUtils.isEmpty(defaction))
            defaction=null;
        this.defaction = defaction;
        this.set("defactiondirtyflag",true);
    }
    /**
     *  获取属性值[访问行为]
     */
    public String getDefaction(){
        return this.defaction;
    }
    /**
     *  重置属性值[访问行为]
     */
    public void resetDefaction(){
        this.set("defactiondirtyflag",false);
        this.defaction = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param deid
     */
    public void setDeid(String deid){
        if(StringUtils.isEmpty(deid))
            deid=null;
        this.deid = deid;
        this.set("deiddirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDeid(){
        return this.deid;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDeid(){
        this.set("deiddirtyflag",false);
        this.deid = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param dename
     */
    public void setDename(String dename){
        if(StringUtils.isEmpty(dename))
            dename=null;
        this.dename = dename;
        this.set("denamedirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDename(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.dename)&&(!StringUtils.isEmpty(this.getDeid())) && this.getDe()!=null)
        {
            this.dename = this.getDe().getDename();
            this.set("denamedirtyflag",true);
        }
        return this.dename;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDename(){
        this.set("denamedirtyflag",false);
        this.dename = null;
    }
    /**
     *  设置属性值[相关属性]
     *  @param relateddefield
     */
    public void setRelateddefield(String relateddefield){
        if(StringUtils.isEmpty(relateddefield))
            relateddefield=null;
        this.relateddefield = relateddefield;
        this.set("relateddefielddirtyflag",true);
    }
    /**
     *  获取属性值[相关属性]
     */
    public String getRelateddefield(){
        return this.relateddefield;
    }
    /**
     *  重置属性值[相关属性]
     */
    public void resetRelateddefield(){
        this.set("relateddefielddirtyflag",false);
        this.relateddefield = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[框架发布]
     *  @param srfsyspub
     */
    public void setSrfsyspub(Integer srfsyspub){
        this.srfsyspub = srfsyspub;
        this.set("srfsyspubdirtyflag",true);
    }
    /**
     *  获取属性值[框架发布]
     */
    public Integer getSrfsyspub(){
        return this.srfsyspub;
    }
    /**
     *  重置属性值[框架发布]
     */
    public void resetSrfsyspub(){
        this.set("srfsyspubdirtyflag",false);
        this.srfsyspub = null;
    }
    /**
     *  设置属性值[应用发布]
     *  @param srfuserpub
     */
    public void setSrfuserpub(Integer srfuserpub){
        this.srfuserpub = srfuserpub;
        this.set("srfuserpubdirtyflag",true);
    }
    /**
     *  获取属性值[应用发布]
     */
    public Integer getSrfuserpub(){
        return this.srfuserpub;
    }
    /**
     *  重置属性值[应用发布]
     */
    public void resetSrfuserpub(){
        this.set("srfuserpubdirtyflag",false);
        this.srfuserpub = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[实体属性访问能力标识]
     *  @param userroledefieldid
     */
    public void setUserroledefieldid(String userroledefieldid){
        if(StringUtils.isEmpty(userroledefieldid))
            userroledefieldid=null;
        this.userroledefieldid = userroledefieldid;
        this.set("userroledefieldiddirtyflag",true);
    }
    /**
     *  获取属性值[实体属性访问能力标识]
     */
    public String getUserroledefieldid(){
        return this.userroledefieldid;
    }
    /**
     *  重置属性值[实体属性访问能力标识]
     */
    public void resetUserroledefieldid(){
        this.set("userroledefieldiddirtyflag",false);
        this.userroledefieldid = null;
    }
    /**
     *  设置属性值[实体属性访问能力]
     *  @param userroledefieldname
     */
    public void setUserroledefieldname(String userroledefieldname){
        if(StringUtils.isEmpty(userroledefieldname))
            userroledefieldname=null;
        this.userroledefieldname = userroledefieldname;
        this.set("userroledefieldnamedirtyflag",true);
    }
    /**
     *  获取属性值[实体属性访问能力]
     */
    public String getUserroledefieldname(){
        return this.userroledefieldname;
    }
    /**
     *  重置属性值[实体属性访问能力]
     */
    public void resetUserroledefieldname(){
        this.set("userroledefieldnamedirtyflag",false);
        this.userroledefieldname = null;
    }
     /**
     *  获取主实体关联数据[DataEntity]
     */
    public DataEntity getDe() {
        return de;
    }
    /**
     *  设置主实体关联数据[DataEntity]
     */
    public void setDe(DataEntity de) {
        this.de = de;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDefaction();
        resetDeid();
        resetDename();
        resetRelateddefield();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetSrfsyspub();
        resetSrfuserpub();
        resetUpdatedate();
        resetUpdateman();
        resetUserroledefieldid();
        resetUserroledefieldname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserRoleDEField copyTo(UserRoleDEField targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserRoleDEField.class, UserRoleDEField.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserroledefieldid();
		return targetEntity;
	}
}